﻿/* 
(C) OOMusou 2011 http://oomusou.cnblogs.com

Filename    : use_lambda.cs
Compiler    : Visual Studio 2008
Description : function pointer by C# 3.0
Release     : 02/12/2011 1.0
*/

using System;
using System.IO;

class use_lambda {
  static void Main(string[] args) {
    Console.WriteLine("1:write to console, 2:write to text");
    int i = Console.Read();
    string s = "Hello World";

    Action<string> m; // Action<T> generic delegate
    
    if (i == 49) 
      m = t => Console.WriteLine(t); // lambda
    else
      m = t => { // lambda
        using (StreamWriter sw = new StreamWriter("test.txt"))
          sw.WriteLine(t);
      };
      
      display_message(m, s);
  }

  static void display_message(Action<string> m, string s) {
    m(s);
  }
}
